unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ExtCtrls, ComCtrls, Classes, Menus, About;

type
  TPalette=array[0..255]of record
                             R,G,B,F: Byte;
                           end;
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    Panel3: TPanel;
    FilterComboBox1: TFilterComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    FileListBox3: TFileListBox;
    RadioGroup1: TRadioGroup;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FileListBox3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;
  function ImageType(FName: string): Integer;

const
  itBMP=1;
  itBMO=2;
  Product_Name='Vangers Converter';
  Product_Version='v1.1';
  Product_Data='29.09.2001';
  Author_Name=' ';
  Author_EMail='collapse_forever@mail.ru';
  Author_http='termius.narod.ru';

var
  Form1: TForm1;
  BMPPalette: TPalette;
  BmpID: ARRAY[1..2]OF Char;
  CurrentFile,CurrentSaveDir: string;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;
  Buffer: array [1..800*2] of Byte;
  FullBuffer: array [1..800*3] of Byte;
  RGBBuffer: array[1..3]of Byte;
  R,G,B: Byte;

implementation

{$R *.DFM}

function ImageType(FName: string): Integer;
var
  x,y,s: Word;
  F: TMemoryStream;
begin
  F:=TMemoryStream.Create;
  F.LoadFromFile(FName);
  F.Read(x,2);
  F.Read(y,2);
  F.Read(s,2);
  if F.Size=(10+(x*y)*s) then Result:=itBMO else
  if F.Size=x*y+4 then Result:=itBMP else Result:=0;
  F.Free;
end;

function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;
var
  F: TFileStream;
  i: Byte;
begin
  if not(FileExists(FName))then
  begin
    LoadPalette:=False;
    Exit;
  end;
  LoadPalette:=True;
  F:=TFileStream.Create(FName,fmOpenRead);
  for i:=0 to 255 do
  begin
    if Invert then
    begin
      F.Read(Pal[i].B,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].R,1);
    end else
    begin
      F.Read(Pal[i].R,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].B,1);
    end;
    Pal[i].F:=$00;
  end;
  F.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadPalette('objects.pal',True,BMPPalette);
  GetDir(0,CurrentSaveDir);
  BmpID[1]:='B';
  BmpID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
var
  FImage,F: TMemoryStream;
  IWidth,IHeight,TS: Word;
  x,y,Add,SavePos: Integer;
  R,G,B: Byte;
begin
  case ImageType(FileListBox1.FileName) of
  itBMP:begin
          ListBox1.Enabled:=False;
          ListBox1.Color:=clBtnFace;
          ListBox1.Items.Clear;
          FImage:=TMemoryStream.Create;
          FImage.LoadFromFile(FileListBox1.FileName);
          FImage.Read(IWidth,2);
          FImage.Read(IHeight,2);
          FImage.Seek($04,soFromBeginning);
          SavePos:=FImage.Position;
          F:=TMemoryStream.Create;
          {***}
          BMPHeader.x:=IWidth;
          BMPHeader.y:=IHeight;
          BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
          BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
          BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
          BMPHeader._H3:=BMPHeader.FullSize-$36;
          {***}
          F.Write(BMPid,2);
          F.Write(BMPHeader,SizeOf(BMPHeader));
          for x:=0 to 255 do
          begin
            R:=BMPPalette[x].R*(RadioGroup1.ItemIndex+1);
            G:=BMPPalette[x].G*(RadioGroup1.ItemIndex+1);
            B:=BMPPalette[x].B*(RadioGroup1.ItemIndex+1);
            F.Write(R,1);
            F.Write(G,1);
            F.Write(B,1);
            F.Write(BMPPalette[x].F,1);
          end;
          Add:=Round(Int((4*(1-(Frac(IWidth/4))))));
          if Add=4 then Add:=0;
          for y:=1 to IHeight do
          begin
            FImage.Seek(SavePos+(IHeight-y)*IWidth,soFromBeginning);
            F.CopyFrom(FImage,IWidth);
            F.Write(Buffer,Add);
          end;
          F.Seek(0,soFromBeginning);
          Image1.Picture.Bitmap.LoadFromStream(F);
          F.Free;
          FImage.Free;
          CurrentFile:=FileListBox1.FileName;
        end;
  itBMO:begin
          ListBox1.Enabled:=True;
          ListBox1.Color:=clWindow;
          FImage:=TMemoryStream.Create;
          FImage.LoadFromFile(FileListBox1.FileName);
          FImage.Seek($04,soFromBeginning);
          FImage.Read(TS,2);
          ListBox1.Items.Clear;
          for x:=1 to TS do ListBox1.Items.Add('Sprite '+IntToStr(x));
          FImage.Free;
          CurrentFile:=FileListBox1.FileName;
        end;
   else ShowMessage(' !');
  end;
end;

procedure TForm1.FileListBox3Click(Sender: TObject);
var
  TempStream: TMemoryStream;
  ImageWidth,ImageHeight,i: Word;
  R,G,B: Byte;
begin
  LoadPalette(FileListBox3.FileName,True,BMPPalette);
  TempStream:=TMemoryStream.Create;
  Image1.Picture.Bitmap.SaveToStream(TempStream);
  TempStream.Seek($36,soFromBeginning);
  for i:=0 to 255 do
  begin
    R:=BMPPalette[i].R*(RadioGroup1.ItemIndex+1);
    G:=BMPPalette[i].G*(RadioGroup1.ItemIndex+1);
    B:=BMPPalette[i].B*(RadioGroup1.ItemIndex+1);
    TempStream.Write(R,1);
    TempStream.Write(G,1);
    TempStream.Write(B,1);
    TempStream.Write(BMPPalette[i].F,1);
  end;
  TempStream.Seek(0,soFromBeginning);
  Image1.Picture.Bitmap.LoadFromStream(TempStream);
  TempStream.Free;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  FImage,F: TMemoryStream;
  IWidth,IHeight: Word;
  x,y,Add,SavePos: Integer;
begin
  FImage:=TMemoryStream.Create;
  FImage.LoadFromFile(FileListBox1.FileName);
  FImage.Read(IWidth,2);
  FImage.Read(IHeight,2);
  FImage.Seek($0A+ListBox1.ItemIndex*(IWidth*IHeight),soFromBeginning);
  F:=TMemoryStream.Create;
  {***}
  BMPHeader.x:=IWidth;
  BMPHeader.y:=IHeight;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  {***}
  F.Write(BMPid,2);
  F.Write(BMPHeader,SizeOf(BMPHeader));
  for x:=0 to 255 do
  begin
    R:=BMPPalette[x].R*(RadioGroup1.ItemIndex+1);
    G:=BMPPalette[x].G*(RadioGroup1.ItemIndex+1);
    B:=BMPPalette[x].B*(RadioGroup1.ItemIndex+1);
    F.Write(R,1);
    F.Write(G,1);
    F.Write(B,1);
    F.Write(BMPPalette[x].F,1);
  end;
  Add:=Round(Int((4*(1-(Frac(IWidth/4))))));
  SavePos:=FImage.Position;
  if Add=4 then Add:=0;
  for y:=1 to IHeight do
  begin
    FImage.Seek(SavePos+(IHeight-y)*IWidth,soFromBeginning);
    F.CopyFrom(FImage,IWidth);
    F.Write(Buffer,Add);
  end;
  F.Seek(0,soFromBeginning);
  Image1.Picture.Bitmap.LoadFromStream(F);
  F.Free;
  FImage.Free;
end;

procedure TForm1.Image1Click(Sender: TObject);
var
  t: string;
begin
  t:=ExtractFileName(CurrentFile);
  t:=Copy(t,1,Pos('.',t))+'bmp';
  SaveDialog1.FileName:=t;
  if SaveDialog1.Execute then Image1.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  FileListBox3.OnClick(Self);
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  ShowAbout(Product_Name,Product_Version,Product_Data,Author_Name,Author_EMail,Author_http);
end;

end.
